//Ŀ
//                                                                           
//  Program Name: PROGBAR.PRG       Copyright: WardStar Consulting           
//  Date Created: 16/07/95           Language: Clipper 5.2e                  
//  Time Created: 22:29:49             Author: Robin Ward                    
//                                                                           
//   Description:                                                            
//                                                                           
//VerRevisedDescriptionĴ
//                                                                           
//   1.00  16/07/95    Created                                               
//                                                                           
//
//   


// Make pseudo Variables with the preprocessor that
// are easier to read, modify  and understand

#define  BARTOP      qself()[1]                  // top row of box  
#define  BARLEFT     qself()[2]                  // left col of box
#define  BARHEADER   qself()[3]                  // header text
#define  BARFOOTER   qself()[4]                  // footer text
#define  BARCOLOR    qself()[5]                  // color of box
#define  BARSCREEN   qself()[6]                  // saved screen under box

#define  BARARRAYSIZE   6                        // array size needed to 
                                                 // store above variables


//==========================================================
// This function is used to create and return a new instance
// of the Progress Bar Class.
//
//----------------------------
function ProgBarNew()
static handle

if handle == nil      

   // create the class
   handle := __ClassNew( "ProgBar", BARARRAYSIZE)

   // add five variables
   __ClassAdd( handle, "Top",     "__BarTop")
   __ClassAdd( handle, "_Top",    "__BarTop")
   __ClassAdd( handle, "Left",    "__BarLeft")
   __ClassAdd( handle, "_Left",   "__BarLeft")
   __ClassAdd( handle, "Header",  "__BarHeader")
   __ClassAdd( handle, "_Header", "__BarHeader")
   __ClassAdd( handle, "Footer",  "__BarFooter")
   __ClassAdd( handle, "_Footer", "__BarFooter")
   __ClassAdd( handle, "Color",   "__BarColor")
   __ClassAdd( handle, "_Color",  "__BarColor")

   // add 4 methods
   __ClassAdd( handle, "Init",    "__BarInit")
   __ClassAdd( handle, "Display", "__BarDisplay")
   __ClassAdd( handle, "Update",  "__BarUpdate")
   __ClassAdd( handle, "Remove",  "__BarRemove")
endif

// create and return an instance of this class
return __ClassIns( handle)


//==========================================================
// The next four functions are the four methods for the class.
//
// These functions must be public so that they can be 
// found at runtime in the symbol table.
//
// These functions (methods) should all return qself().  This
// returns the current object so that you can chain methods.
//
//----------------------------
function __BarInit( nTop, nLeft, cHeader, cFooter, cColor)

// initialize the object with the passed vars or use defaults
BARTOP     := iif( nTop<>nil,    nTop,    int((maxrow()-4)/2) )
BARLEFT    := iif( nLeft<>nil,   nLeft,   int((maxcol()-54)/2) )
BARHEADER  := iif( cHeader<>nil, cHeader, "> Percent Completed <" )
BARFOOTER  := iif( cFooter<>nil, cFooter, "> Please Wait <" )
BARCOLOR   := iif( cColor<>nil,  cColor,  "G/GR+" )
return qself()


//----------------------------
function __BarDisplay()
local nRow := row()
local nCol := col()
local cStr

// save the current screen
BARSCREEN := SaveScreen( BARTOP, BARLEFT, BARTOP+5, BARLEFT+56)

// put a shadow for the box
cStr := SaveScreen( BARTOP+1, BARLEFT+2, BARTOP+5, BARLEFT+56)
cStr := transform( cStr, replicate( "A"+chr(8), len(cStr)))
RestScreen( BARTOP+1, BARLEFT+2, BARTOP+5, BARLEFT+56, cStr)

// draw the box and the markers
@ BARTOP, BARLEFT, BARTOP+4, BARLEFT+54 box "Ŀ " color BARCOLOR
@ BARTOP+3, BARLEFT+2 say "                                        " color BARCOLOR

// show the header and footer text
@ BARTOP,   BARLEFT+1 say padc(BARHEADER, 53, "") color BARCOLOR
@ BARTOP+4, BARLEFT+1 say padc(BARFOOTER, 53, "") color BARCOLOR

setPos( nRow, nCol)
return qself()


//----------------------------
function __BarUpdate( nDone)
local nRow := row()
local nCol := col()

// make sure percent done is within range
if nDone < 0
   nDone := 0
elseif nDone > 100
   ndone := 100
endif

// show percent done
@ BARTOP+1, BARLEFT+25 say str(nDone,3)+"%" color BARCOLOR

// show progress bar
@ BARTOP+2, BARLEFT+2  say padr(replicate("",((nDone*.51)+.5)),51,".") color BARCOLOR

setPos( nRow, nCol)
return qself()


//----------------------------
function __BarRemove()

// remove the progress bar, restore screen
if BARSCREEN <> nil
   RestScreen( BARTOP, BARLEFT, BARTOP+5, BARLEFT+56, BARSCREEN)
   BARSCREEN := nil
endif
return qself()


//==========================================================
// The next five functions are Get/Set functions for the 
// five public variables of this class.
//
// These functions must be public so that they can be 
// found at runtime in the symbol table.
//
//----------------------------
function __BarTop( nTop)
return iif(nTop==nil, BARTOP, BARTOP := nTop)

//----------------------------
function __BarLeft( nLeft)
return iif(nLeft==nil, BARLEFT, BARLEFT := nLeft)

//----------------------------
function __BarHeader( cHeader)
return iif(cHeader==nil, BARHEADER, BARHEADER := cHeader)

//----------------------------
function __BarFooter( cFooter)
return iif(cFooter==nil, BARFOOTER, BARFOOTER := cFooter)

//----------------------------
function __BarColor( cColor)
return iif(cColor==nil, BARCOLOR, BARCOLOR := cColor)

//----------------------------
