//Ŀ
//                                                                           
//  Program Name: XDEMO3.PRG         Copyright: WardStar Consulting          
//  Date Created: 17/07/95           Language: Clipper 5.2e                  
//  Time Created: 21:43:49             Author: Robin Ward                    
//                                                                           
//   Description:   Simple DBF Viewer, shows use of Scroll Bars              
//                                                                           
//VerRevisedDescriptionĴ
//                                                                           
//   1.00  17/07/95    Created                                               
//                                                                           
//   1.01  30/07/95    Add PanUp and PanDown()                               
//                     Keep a minimum number of rows visible                 
//                                                                           
//
//   

#include "inkey.ch"
#include "dbstruct.ch"

#include "ScrolBar.ch"


//==================================
function main( cDbf)

local oTbr
local aStruct
local key
local x

set date british
setcolor("n/bg,w/r")


if valtype( cDbf) != "C"
   ? "Simple DBF file viewer"
   ?
   ? "XDEMO3  dbffile"
   ?
   quit
endif

if !file( cDbf+".dbf")
   ? "file "+cDbf+".dbf ???"
endif


// Add the new methods and variables to the tbrowse class
AddScrollBars()


use (cDbf) new
aStruct := dbstruct()

// create a tbrowse for the database
oTbr := tbrowsedb(1,0,maxrow(),maxcol()-1)
oTbr:headSep := ""
oTbr:ColSep  := ""
oTbr:FootSep := ""
for x := 1 to fcount()
   oTbr:addcolumn( tbcolumnnew(fieldname(x), fieldblock(field(x))) )
   if aStruct[x,DBS_TYPE] == "M"
      oTbr:getcolumn(x):block := {|| "  <Memo>  "}
   endif
next


cls
setcursor(0)
@ 0,10 say upper(cDbf) color "r/bg"


// initialize the tbrowse with the scroll bar variables
oTbr:BarInit()

do while .t.
   do while !oTbr:stabilize() .and. nextkey()==0
   enddo

   if nextkey() == 0
      ShowStats( oTbr)
   endif

   // update the scroll bar display
   oTbr:BarUpdate()

   key := inkey(0)
   if setkey( key) <> nil
      eval( setkey(key), procname(), procline(), key)
   endif

   do case

      // altered to keep at least 1/3 of the display visible
   case key == K_UP
      if oTbr:RowPos < oTbr:RowCount * 1/3
         oTbr:PanUp()
      endif
      oTbr:up()

      // altered to keep at least 1/3 of the display visible
   case key == K_DOWN
      if oTbr:RowPos > oTbr:RowCount * 2/3
         oTbr:PanDown()
      endif
      oTbr:down()

      // new method to pan the screen up
   case key == K_CTRL_UP
      oTbr:PanUp()

      // new method to pan the screen down
   case key == K_CTRL_DOWN
      oTbr:PanDown()

   case key == K_ESC
      exit

   otherwise
      MoveTbrowse( key, oTbr)
   endcase
enddo


setcursor(1)
close all
return nil


//==================================
static function MoveTbrowse( key, o)

do case
case key == K_UP           ; o:up()
case key == K_DOWN         ; o:down()
case key == K_LEFT         ; o:left()
case key == K_RIGHT        ; o:right()
case key == K_PGUP         ; o:pageUp()
case key == K_PGDN         ; o:pageDown()
case key == K_CTRL_PGUP    ; o:goTop()
case key == K_CTRL_PGDN    ; o:goBottom()
case key == K_HOME         ; o:home()
case key == K_END          ; o:end()
case key == K_CTRL_HOME    ; o:panHome()
case key == K_CTRL_END     ; o:panEnd()
case key == K_TAB          ; o:panRight()
case key == K_SH_TAB       ; o:panLeft()
endcase
return nil


//==================================
static function ShowStats( o)
local status

do case
case reccount() == 0
   status := "<empty>"
case o:hitTop()
   status := "<bof>"
case o:hitBottom()
   status := "<eof>"
otherwise
   status := "Record " + ltrim(str(recno())) + "/" +ltrim(str(reccount()))
endcase
@ 0,maxcol()-43 say padr(status,20)
@ 0,maxcol()-22 say padr("Field " + ltrim(str(o:colpos())) + "/" +ltrim(str(fcount())), 20)
return nil


//==================================
procedure help
local OldScreen := savescreen()
alert( ";;XDEMO3;Simple DBF Viewer;;"    ;
   + "(C) Copyright 1995  Robin Ward;;" ;
   + "Shows use of Scroll bars in a "   ;
   + "modified tbrowse;;"               ;
   + "New Methods: PanUp, PanDown()")
restscreen(,,,,OldScreen)
return


//==================================
